#include "../util/graphs.hpp"

namespace cr {

  // apply the B-bridge rule:
  // Let T' be a proper subtree of the component tree T of G whose unique incident B-bridge in G is {u,v} (with v in T').
  // Let S1 , S2' , and S3 denote optimal solutions of G[T'], G[T'-v], and G[T'+u] and
  // let S2 := S2 cup {{v, w} in E(G) | w = u}.
  // (a) If |S1 | < |S3 |, then apply S1 + {u, v} to G.
  // (b) If not (a), but |S2 | = |S3 |, then apply S2 to G.
  // (c) If neither (a) nor (b), then apply S3 to G.
  solution_t apply_Bbridge_rule(instance& I);

  // split rule: find bridge {u,v} such that deg(v)>1 and all w in N[v] have nldeg < 3, then split {u,v} from v
  // return whether a split was done
  bool apply_split_rule(instance& I);

  // apply the final reduction rule when nothing else is applicable anymore
  solution_t apply_final_RR(instance& I);


};
